import React from 'react';
import { UseSelector } from '../core/useSelector';
export declare type CreateGlobalContextArgs = {
    [partial: string]: {
        reducer: AnyReducer;
        initialState: any;
    };
};
export declare type CreateGlobalContextResult<T extends CreateGlobalContextArgs> = [
    UseSelector<GlobalContextValue<T>>,
    React.FC,
    () => GlobalContextValue<T>['state']
];
export declare type AnyReducer<S = any, A = any> = React.Reducer<S, A> | React.ReducerWithoutAction<S>;
export declare type ReducerState<R> = R extends React.ReducerWithoutAction<any> ? React.ReducerStateWithoutAction<R> : R extends React.Reducer<any, any> ? React.ReducerState<R> : never;
export declare type ReducerDispatch<R> = R extends React.ReducerWithoutAction<any> ? React.DispatchWithoutAction : R extends React.Reducer<any, any> ? React.Dispatch<React.ReducerAction<R>> : never;
export declare type State<T extends CreateGlobalContextArgs> = {
    [P in keyof T]: T[P]['initialState'];
};
export declare type GlobalContextValue<T extends CreateGlobalContextArgs> = {
    state: {
        [P in keyof T]: T[P]['initialState'];
    };
    dispatch: {
        [P in keyof T]: ReducerDispatch<T[P]['reducer']>;
    };
};
export declare const createGlobalContext: <T extends CreateGlobalContextArgs>(args: T) => CreateGlobalContextResult<T>;
